#include "rolodex_dict.h"

AFun afun0;
AFun afun1;
AFun afun2;
AFun afun3;

ATerm patternPhoneNumberFax = NULL;
ATerm patternPhoneNumberVoice = NULL;
ATerm patternRolodexWork = NULL;
ATerm patternRolodexHome = NULL;
ATerm patternRoloListMany = NULL;
ATerm patternRoloListSingle = NULL;
ATerm patternRoloListEmpty = NULL;

/*
 * afun0 = home(x)
 * afun1 = work(x)
 * afun2 = voice(x)
 * afun3 = fax(x)
 *
 * patternPhoneNumberFax = fax(<int>)
 * patternPhoneNumberVoice = voice(<int>)
 * patternRolodexWork = work([<str>,<term>])
 * patternRolodexHome = home([<str>,<term>])
 * patternRoloListMany = [<term>,<list>]
 * patternRoloListSingle = [<term>]
 * patternRoloListEmpty = []
 *
 */

static ATerm _rolodex_dict = NULL;

#define _rolodex_dict_LEN 155

static char _rolodex_dict_baf[_rolodex_dict_LEN] = {
0x00,0x8B,0xAF,0x83,0x00,0x0C,0x23,0x03,0x3C,0x5F,0x3E,0x01,0x00,0x04,0x04,0x05,
0x06,0x04,0x03,0x05,0x5B,0x5F,0x2C,0x5F,0x5D,0x02,0x00,0x11,0x07,0x01,0x02,0x00,
0x08,0x09,0x0A,0x0B,0x02,0x01,0x02,0x02,0x5B,0x5D,0x00,0x00,0x01,0x03,0x69,0x6E,
0x74,0x00,0x00,0x01,0x03,0x73,0x74,0x72,0x00,0x00,0x01,0x04,0x6C,0x69,0x73,0x74,
0x00,0x00,0x01,0x04,0x74,0x65,0x72,0x6D,0x00,0x00,0x01,0x01,0x78,0x00,0x00,0x01,
0x04,0x68,0x6F,0x6D,0x65,0x01,0x00,0x02,0x02,0x01,0x07,0x04,0x77,0x6F,0x72,0x6B,
0x01,0x00,0x02,0x02,0x01,0x07,0x05,0x76,0x6F,0x69,0x63,0x65,0x01,0x00,0x02,0x02,
0x00,0x07,0x03,0x66,0x61,0x78,0x01,0x00,0x02,0x02,0x00,0x07,0x01,0x18,0xC4,0x20,
0x91,0x0A,0x40,0x19,0x47,0x83,0x9C,0x0C,0x5A,0xC0,0x0C,0x62,0x8A,0x20,0x89,0x48,
0xD6,0x8A,0x0A,0x1C,0x48,0x62,0xC2,0x24,0x08,0x0A,0x50
};

void init_rolodex_dict()
{
  ATermList afuns, terms;

  _rolodex_dict = ATreadFromBinaryString(_rolodex_dict_baf, _rolodex_dict_LEN);

  ATprotect(&_rolodex_dict);

  afuns = (ATermList)ATelementAt((ATermList)_rolodex_dict, 0);

  afun0 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  afun1 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  afun2 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);
  afun3 = ATgetAFun((ATermAppl)ATgetFirst(afuns));
  afuns = ATgetNext(afuns);

  terms = (ATermList)ATelementAt((ATermList)_rolodex_dict, 1);

  patternPhoneNumberFax = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternPhoneNumberVoice = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternRolodexWork = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternRolodexHome = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternRoloListMany = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternRoloListSingle = ATgetFirst(terms);
  terms = ATgetNext(terms);
  patternRoloListEmpty = ATgetFirst(terms);
  terms = ATgetNext(terms);
}
